SET DEFINE OFF;

--
-- 
-- ____________________________________________________________________________________________
--  /!\ ATTENTION /!\  fichier encodé en UTF-8   (  il peut  contenir des é è ç à î ê ô ... )
-- ____________________________________________________________________________________________
--
--

--
-- 
-- Fichier: n°3
-- Type: DDL
-- Schéma:  RECHERCHE
-- Numéro de version :  1.0.0.0
-- Date de publication :  07/12/2010
-- Auteurs : Julien Lafourcade, Bruno Garnier
-- Licence : CeCILL version 2
--
--


/*
	Création des tables pour la partie production scientifique
*/


whenever sqlerror exit sql.sqlcode ;

CREATE TABLE RECHERCHE.AAP
(
AAP_ORDRE NUMBER NOT NULL,
CON_ORDRE NUMBER NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
D_CREATION DATE, 
PERS_ID_MODIFICATION NUMBER, 
D_MODIFICATION DATE, 
DATE_DEPOT_DOSSIER DATE NOT NULL,
MOYEN_DEPOT_DOSSIER VARCHAR2(30),
DOSSIER_COMPLET NUMBER(1),
AVIS_RAPPORTEUR_DESIGNE VARCHAR2(30),
DATE_PASSAGE_CONSEIL_RECHERCHE DATE,
AVIS_PASSAGE_CONSEIL_RECHERCHE VARCHAR2(30),
DATE_PASSAGE_COM_MIXTE DATE,
AVIS_PASSAGE_COM_MIXTE VARCHAR2(30),
DATE_PASSAGE_CS DATE,
AVIS_PASSAGE_CS VARCHAR2(30),
DATE_ENV_DOSSIER_FIN DATE,
SUPPORT_ENV_FINANCEUR VARCHAR2(10),
DATE_COM_PERMANANT DATE,
TYPE_FINANCEMENT_DEMANDE VARCHAR2(50),
CLASSEMENT_PASSAGE_CS NUMBER,
ETAT_ACCEPT VARCHAR2(10),
DATE_REFUS_ACCEPT DATE,
APP_DOMAINE_SCIENT_ORDRE NUMBER,
APP_PROG_ID NUMBER,
APP_SS_PROG_ID NUMBER,
MOY_NOTIF_REF_ACC VARCHAR2(10),
MONTANT_DEMANDE NUMBER,
SUBVENTION_OBT NUMBER(1), 
MONTANT_OBT NUMBER,
TYPE_SUBV_OBT VARCHAR2(10),
SUIVI_VALO VARCHAR2(10),
D_ALERTE_SUIVI DATE,
SUJET_ALERTE_SUIVI VARCHAR2(250),
D_TRANSFERT_VALO DATE,
D_TRANSFERT_FINANCIER DATE,
D_ALERTE DATE,
SUJET_ALERTE VARCHAR2(250),
D_ARCHIVAGE DATE,
ETAT_MONTAGE VARCHAR2(10),
AAP_SUPPR NUMBER(1) DEFAULT 0
);

ALTER TABLE RECHERCHE.AAP ADD (PRIMARY KEY (AAP_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.AAP ADD (
	CONSTRAINT FK_AAP_DOMAINE_SCIENTIFIQUE 
	FOREIGN KEY (APP_DOMAINE_SCIENT_ORDRE) 
	REFERENCES GRHUM.DOMAINE_SCIENTIFIQUE (DS_ORDRE) DEFERRABLE INITIALLY DEFERRED
);

CREATE TABLE RECHERCHE.CONTRAT_RECHERCHE
(
CONR_ORDRE NUMBER NOT NULL,
CON_ORDRE NUMBER NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
PERS_ID_MODIFICATION NUMBER					  ,
D_CREATION DATE NOT NULL, 
D_MODIFICATION DATE,
PROGRAMME_ID NUMBER,
SS_PROGRAMME_ID NUMBER,
DATE_OUVERT_DOSSIER DATE,
DATE_NOTIF DATE,
DATE_ARCHIVAGE DATE,
ZG_ORDRE NUMBER,
TYPE_INTERVENTION VARCHAR2(10),
SUIVI_ADMIN VARCHAR2(10),
REDACTION_CONTRAT VARCHAR2(10),
REDACTION_CLAUSES_PI VARCHAR2(10),
PARTICIAPATION_DAJ_NEGO NUMBER(1),
UTIL_CONTRAT_TYPE_DAJ NUMBER(1),
MONTANT_AUGMENTATION NUMBER,
PROPRIETE_RESULTATS VARCHAR2(10),
EXPLOITATION_RESULTATS VARCHAR2(10),
SUIVI_VALO VARCHAR2(10),
SUIVI_VALO_EVT_ID NUMBER,
TAUX_PRELEV_EFFECT NUMBER,
MONTANT_PRELEV_REFFECT NUMBER,
REDEVANCES NUMBER(1),
SOUMIS_TVA NUMBER(1),
TAUX_TVA NUMBER,
MONTANT_DEMANDE NUMBER,
SUBVENTION_OBT NUMBER(1), 
MONTANT_OBT NUMBER,
DOMAINE_SCIENT_ORDRE NUMBER,
CR_SUPPR NUMBER(1)
);

ALTER TABLE RECHERCHE.CONTRAT_RECHERCHE ADD (PRIMARY KEY (CONR_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.CONTRAT_RECHERCHE ADD (
	CONSTRAINT FK_CONR_EVT_SUIVI 
	FOREIGN KEY (PERS_ID_MODIFICATION) 
	REFERENCES GRHUM.EVT_EVENEMENT (EVT_ID) DEFERRABLE INITIALLY DEFERRED
);

CREATE TABLE RECHERCHE.REPART_CONTRAT_LANGUE
(
RCL_ORDRE NUMBER NOT NULL,
CONR_ORDRE NUMBER NOT NULL,
C_LANGUE VARCHAR2(2) NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
PERS_ID_MODIFICATION NUMBER					  ,
D_CREATION DATE NOT NULL, 
D_MODIFICATION DATE
);

ALTER TABLE RECHERCHE.REPART_CONTRAT_LANGUE ADD (PRIMARY KEY (RCL_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_CONTRAT_LANGUE
ADD (
	CONSTRAINT FK_RCL_LANGUE 
	FOREIGN KEY (C_LANGUE) 
	REFERENCES GRHUM.LANGUE (C_LANGUE) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.REPART_CONTRAT_LANGUE
ADD (
	CONSTRAINT FK_RCL_CONTRAT 
	FOREIGN KEY (CONR_ORDRE) 
	REFERENCES RECHERCHE.CONTRAT_RECHERCHE (CONR_ORDRE) DEFERRABLE INITIALLY DEFERRED
);


--
-- REPARTITION DES APPORTS DRV POUR LES CONTRATS
--

CREATE TABLE RECHERCHE.REPART_APPORT_DRV_CONT
(
RADRVC_ORDRE NUMBER NOT NULL,
CONR_ORDRE NUMBER NOT NULL,
APPORT_CONT_DRV VARCHAR2(20) NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
PERS_ID_MODIFICATION NUMBER					  ,
D_CREATION DATE NOT NULL, 
D_MODIFICATION DATE
);

ALTER TABLE RECHERCHE.REPART_APPORT_DRV_CONT ADD (PRIMARY KEY (RADRVC_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_APPORT_DRV_CONT
ADD (
	CONSTRAINT FK_RADRV_CONTRAT 
	FOREIGN KEY (CONR_ORDRE) 
	REFERENCES RECHERCHE.CONTRAT_RECHERCHE (CONR_ORDRE) DEFERRABLE INITIALLY DEFERRED
);

--
-- REPARTITION DES APPORTS DAJ POUR LES CONTRATS
--

CREATE TABLE RECHERCHE.REPART_APPORT_DAJ_CONT
(
RADAJC_ORDRE NUMBER NOT NULL,
CONR_ORDRE NUMBER NOT NULL,
APPORT_CONT_DAJ VARCHAR2(20) NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
PERS_ID_MODIFICATION NUMBER					  ,
D_CREATION DATE NOT NULL, 
D_MODIFICATION DATE
);

ALTER TABLE RECHERCHE.REPART_APPORT_DAJ_CONT ADD (PRIMARY KEY (RADAJC_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_APPORT_DAJ_CONT
ADD (
	CONSTRAINT FK_RADAJ_CONTRAT 
	FOREIGN KEY (CONR_ORDRE) 
	REFERENCES RECHERCHE.CONTRAT_RECHERCHE (CONR_ORDRE) DEFERRABLE INITIALLY DEFERRED
);

-- REPARTITION DES TYPES DE RESULTATS POUR LES CONTRATS

CREATE TABLE RECHERCHE.REPART_TYPE_RES_CONT
(
RTRC_ORDRE NUMBER NOT NULL,
CONR_ORDRE NUMBER NOT NULL,
TYPE_RES VARCHAR2(20) NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
PERS_ID_MODIFICATION NUMBER					  ,
D_CREATION DATE NOT NULL, 
D_MODIFICATION DATE
);

ALTER TABLE RECHERCHE.REPART_TYPE_RES_CONT ADD (PRIMARY KEY (RTRC_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_TYPE_RES_CONT
ADD (
	CONSTRAINT FK_RTR_CONTRAT 
	FOREIGN KEY (CONR_ORDRE) 
	REFERENCES RECHERCHE.CONTRAT_RECHERCHE (CONR_ORDRE) DEFERRABLE INITIALLY DEFERRED
);

-- ETATS DE VALIDATION DES CONTRATS

CREATE TABLE RECHERCHE.VALIDATION_CONTRATS 
(
  VC_ORDRE NUMBER NOT NULL,
  CONR_ORDRE NUMBER NOT NULL,
  T_VALIDATION VARCHAR2(20) NOT NULL,
  VALIDE NUMBER NOT NULL,
  DATE_VALIDATION DATE,
  COMMENTAIRE VARCHAR2(1024),
  PERS_ID_CREATION NUMBER NOT NULL, 
  PERS_ID_MODIFICATION NUMBER,
  D_CREATION DATE NOT NULL, 
  D_MODIFICATION DATE
);

ALTER TABLE RECHERCHE.VALIDATION_CONTRATS ADD (PRIMARY KEY (VC_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);
  
ALTER TABLE RECHERCHE.VALIDATION_CONTRATS
ADD (
	CONSTRAINT FK_VC_CONTRAT 
	FOREIGN KEY (CONR_ORDRE) 
	REFERENCES RECHERCHE.CONTRAT_RECHERCHE (CONR_ORDRE) DEFERRABLE INITIALLY DEFERRED
);  
  
-- REPARTITION TYPES FINANCEMENTS AAP

CREATE TABLE RECHERCHE.REPART_TYPE_FINANC_AAP 
(
  RTFC_ORDRE NUMBER NOT NULL,
  AAP_ORDRE NUMBER NOT NULL,
  T_FINANCEMENT VARCHAR2(20) NOT NULL,
  MONTANT_DEMANDE NUMBER,
  MONTANT_OBTENU NUMBER,
  PERS_ID_CREATION NUMBER NOT NULL, 
  PERS_ID_MODIF NUMBER,
  D_CREATION DATE NOT NULL, 
  D_MODIFICATION DATE
);

ALTER TABLE RECHERCHE.REPART_TYPE_FINANC_AAP ADD (PRIMARY KEY (RTFC_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);
  
ALTER TABLE RECHERCHE.REPART_TYPE_FINANC_AAP
ADD (
	CONSTRAINT FK_RTFC_AAP
	FOREIGN KEY (AAP_ORDRE) 
	REFERENCES RECHERCHE.AAP (AAP_ORDRE) DEFERRABLE INITIALLY DEFERRED
);  


-- PROJET SCIENTIFIQUE

CREATE TABLE RECHERCHE.PROJET_SCIENTIFIQUE
(
PRSC_ORDRE                   NUMBER           NOT NULL,
PJT_ID					     NUMBER			  NOT NULL,
PERS_ID_CREATION			 NUMBER			  NOT NULL, 
PERS_ID_MODIFICATION         NUMBER					  ,
D_CREATION                   DATE             NOT NULL, 
D_MODIFICATION               DATE			          ,
PRSC_SUPPR                   NUMBER(1)
);

ALTER TABLE RECHERCHE.PROJET_SCIENTIFIQUE ADD (PRIMARY KEY (PRSC_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

	
CREATE TABLE RECHERCHE.PROGRAMMES
(
PROG_ORDRE NUMBER NOT NULL,
PROG_PERE NUMBER,
C_STRUCTURE VARCHAR2(10) NOT NULL,
LL_PROGRAMME VARCHAR2(100) NOT NULL,
PERS_ID_CREATION NUMBER NOT NULL, 
PERS_ID_MODIFICATION NUMBER,
D_CREATION DATE NOT NULL, 
D_MODIFICATION DATE
);

ALTER TABLE RECHERCHE.PROGRAMMES ADD (PRIMARY KEY (PROG_ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.PROGRAMMES ADD (
	CONSTRAINT FK_PROG_REF_STRUCT 
	FOREIGN KEY (C_STRUCTURE) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.PROGRAMMES ADD (
	CONSTRAINT FK_PROG_REF_PROG_PERE 
	FOREIGN KEY (PROG_PERE) 
	REFERENCES RECHERCHE.PROGRAMMES (PROG_ORDRE) DEFERRABLE INITIALLY DEFERRED
);

